/*******************************************************************************
 * pipe.c
 * This file is part of "Lab 3: Pipe"
 * Copyright (C) 2009 - c506001 (email: c506001@cse.hcmut.edu.vn )
 *
 * Content:
 * --------
 * The Main Program
 *
 * System and Networking Department
 * Faculty of Computer Science and Engineering
 * Ho Chi Minh City University of Technology
 ******************************************************************************/


#include <stdio.h>
#include <unistd.h>
#include "pipe.h"

//TODO: initialize variables
int fp[2];        // pipe for parent sending commands to child
int ack[2];       // pipe for child sending ack to parent

//TODO: declare functions used in main()

int main(int argc, char **argv) {
  //TODO: parse options (arguments)

  // create pipes
  pipe(fp);
  pipe(ack);
  
  pid_t pid=fork();
  if (pid>0) {
    // parent process
    doParent();
    wait(NULL);
  } 
  else if (pid==0){
    // child process
    doChild();
  } 
  else {
    perror("Error in forking new process");
    return -1;
  }
  
  return 0;
}

/**
 * Function name: doParent
 * Description:
 *    Parent process
 * Return value:
 *    Exit if errors
 **/
static void doParent(){
  close(fp[0]);
  close(ack[1]);

  //TODO: open input file
  //      if can not open the input file, show error string "Can not open the input file: inputfilename"

  //TODO: read each line to get command
  while (/*get new command*/){
    //TODO: send command to child process and wait for receiving ack
  }

  //TODO: close input file
}

/**
 * Function name: doChild
 * Description:
 *    Parent process
 * Return value:
 *    Exit if errors
 **/
static void doChild(){
  char command[1024];	// contain command sent from parent process
  close(fp[1]);
  close(ack[0]);

  //TODO: open ouput file for redirecting
  //      if can not open the output file, show error string "Can not open the output file: outputfilename"

  //TODO: open error file for redirecting
  //      if can not open the error file, show error string "Can not open the error file: errorfilename"
  
  //TODO: redirect output and error to ouput and error files

  //TODO: read each command sent from parent and process it
  while (/*read command from pipe*/){
    //TODO: print the number order of command to output and error files
    
    // run command, output and error of this command is automatically redirected to output and error files
    system(command);

    //TODO: send ack to parent through ack pipe
  }
  
  //TODO: close output and error file
}

/**
 * Function name: Usage
 * Description:
 *    Show helping information when user uses -h option
 **/
static void Usage(){
  printf("SYNOPSIS: pipe [-h] [-i filename] [-o filename] [-e filename]\n");
  printf("	[-h]          : Show help information\n");
  printf("	[-i] filename : Choose the input file\n");
  printf("	[-o] filename : Choose the output file\n");
  printf("	[-e] filename : Choose the error file\n");
}


/**
 * Function name: parseArguments
 * Description:
 *    Determine what options or arguments user used
 *    Command-line options:
 * 	 [-h]         : Show help information
 *	 [-i] filename: Choose the input file
 *	 [-o] filename: Choose the output file
 *	 [-e] filename: Choose the error file
 * Return value:
 *    0: If parsing successful
 *    exit: If error
 **/
static int parseArguments(int argc, char **argv)
{
  int opt;
  extern int optind;

  while ((opt = getopt(argc, argv, "")) != EOF)
  {
    switch (opt) {

      //TODO: Parse option -h, -i, -o and -e

      default:
        fprintf(stderr, "Try 'pipe -h' for more information\n");
        exit(1);
    }
  }

  if (optind < argc) {
    fprintf(stderr, "Invalid command syntax\n");
    fprintf(stderr, "Try 'pipe -h' for helping\n");
    exit(1);
  }
    
  return 0;
}
